﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;


//using Newtonsoft.Json;
//using Newtonsoft.Json.Linq;
using igSorting.Models;
using Infragistics.Web.Mvc;

namespace iggrid.Controllers
{
    public class HomeController : Controller
    {
        //
        // GET: /Sorting/
        public ActionResult Index()
        {
            var tuple = new Tuple<IQueryable<MessageLogModel>, SettingsModel>(GetMessageLogList(), GetSettings());
            return View(tuple);
        }

        [GridDataSourceAction]
        public ActionResult GridDS(string fileID)
        {
            return View(GetMessageLogList());
        }

        [HttpPost]
        public ActionResult FilterResult( bool filter)
        {
            SettingsModel settings = new SettingsModel();
            settings.Filter = filter;

            //hard coded
            bool dbResult = true;

            JsonResult result = new JsonResult();
            Dictionary<string, Object> response = new Dictionary<string, Object>();

            if (dbResult)
                response.Add("Success", true);
            else
                response.Add("Success", false);

            result.Data = response;
            return result;
        }

        public IQueryable<MessageLogModel> GetMessageLogList()
        {
            MessageLogModel msgLog = new MessageLogModel();

            List<MessageLogModel> lstMsgLog = new List<MessageLogModel>();
            msgLog.ID = 1;
            msgLog.Message = "Message 1";
            msgLog.StartDate = DateTime.Now.AddDays(4);
            msgLog.ErrorMsg = "Error 1";
            lstMsgLog.Add(msgLog);

            msgLog = new MessageLogModel();
            msgLog.ID = 2;
            msgLog.Message = "";
            msgLog.StartDate = DateTime.Now.AddDays(2);
            msgLog.ErrorMsg = "Error2";
            lstMsgLog.Add(msgLog);

            msgLog = new MessageLogModel();
            msgLog.ID = 3;
            msgLog.Message = "Message 3";
            msgLog.StartDate = DateTime.Now.AddDays(3);
            msgLog.ErrorMsg = "";
            lstMsgLog.Add(msgLog);

            msgLog = new MessageLogModel();
            msgLog.ID = 4;
            msgLog.Message = "Message 4";
            msgLog.StartDate = DateTime.Now.AddDays(1);
            msgLog.ErrorMsg = "Error 1";
            lstMsgLog.Add(msgLog);

            msgLog = new MessageLogModel();
            msgLog.ID = 5;
            msgLog.Message = "Message 5";
            msgLog.StartDate = DateTime.Now.AddDays(5);
            msgLog.ErrorMsg = "Error 5";
            lstMsgLog.Add(msgLog);

            msgLog = new MessageLogModel();
            msgLog.ID = 6;
            msgLog.Message = "Message 6";
            msgLog.StartDate = DateTime.Now.AddDays(6);
            msgLog.ErrorMsg = "Error 6";
            lstMsgLog.Add(msgLog);

            msgLog = new MessageLogModel();
            msgLog.ID = 7;
            msgLog.Message = "Message 7";
            msgLog.StartDate = DateTime.Now.AddDays(7);
            msgLog.ErrorMsg = "Error 7";
            lstMsgLog.Add(msgLog);

            msgLog = new MessageLogModel();
            msgLog.ID = 8;
            msgLog.Message = "Message 8";
            msgLog.StartDate = DateTime.Now.AddDays(8);
            msgLog.ErrorMsg = "Error 8";
            lstMsgLog.Add(msgLog);

            return lstMsgLog.AsQueryable();
        }
        public SettingsModel GetSettings()
        {
            SettingsModel settings = new SettingsModel();
            settings.Filter = false;
            return settings;
        }
	}
}